/*
 * ConsumerSideEventBus.java
 *
 * Created on August 26, 2002, 3:54 PM
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena;
import siena.*;
import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.*;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.Events.*;
import java.util.*;
/**
 *
 * @author  schmerl
 */
public class ConsumerSideEventBus extends SienaEventBus {
    
    private Vector eventBindings = new Vector ();
    
    /** Creates a new instance of ConsumerSideEventBus */
    public ConsumerSideEventBus (String senp) {
        initializeSiena (senp);
    }
    
    public void notify (siena.Notification e) throws siena.SienaException {
        try {
        GaugeID gauge = new GaugeID ();
        extractGaugeID (gauge, e);       
        boolean matches = false;
        Enumeration bindings = eventBindings.elements ();
        
        while (bindings.hasMoreElements ()) {
           NotificationHandlerGauge fh = (NotificationHandlerGauge )bindings.nextElement ();
            if (gauge.equals (fh.gauge.getGaugeID ())) {
                // Get event type
                AttributeValue av = fh.filterAsNotification.getAttribute (EVENTTYPE);
                if (av != null && e.getAttribute (EVENTTYPE).stringValue ().equals (av.stringValue ())) {
                    String eventType = av.stringValue ();
                    if (eventType.equals (CREATED)) {
                        if (fh.handler instanceof GaugeConsumer) {
                            ((GaugeConsumer )fh.handler).onReportCreated (fh.gauge);
                        }
                    }
                    else if (eventType.equals (DELETED)) {
                        if (fh.handler instanceof GaugeConsumer) {
                            ((GaugeConsumer )fh.handler).onReportDeleted (fh.gauge);
                        }
                    }
                    else if (eventType.equals (CONFIGURED)) {
                        if (fh.handler instanceof GaugeConsumer) {
                            StringPairVector configParams = new StringPairVector ();
                            Notification2SPV (e, configParams, CONFIG);
                            ((GaugeConsumer )fh.handler).onReportConfigured (fh.gauge, configParams);
                        }
                    }
                    else if (eventType.equals (VALUE)) {
                        if (fh.handler instanceof GaugeConsumer) {
                            String valueName = e.getAttribute (VALUENAME).stringValue ();
                            String propertyName = e.getAttribute (PROPERTYNAME).stringValue ();
                            String value = e.getAttribute (VALUE).stringValue ();
                            ((GaugeConsumer )fh.handler).onReportValue (fh.gauge, valueName, propertyName, value);
                        }
                    }
                    else if (eventType.equals (MULTIPLEVALUES)) {
                        if (fh.handler instanceof GaugeConsumer) {
                            GaugeValueVector gvv = new GaugeValueVector ();
                            Notification2GVV (e, gvv, VALUE);
                            ((GaugeConsumer )fh.handler).onReportMultipleValues (fh.gauge, gvv);
                        }
                    }
                }
            }
        }
        }
         catch (Exception ex) {
            ex.printStackTrace ();
            if (ex instanceof SienaException) {
                throw (SienaException )ex;
            }
            else {
                throw new SienaException (ex.toString ());
            }
        }
    }
    
    protected Notification prepareAnnouncement (GaugeEvent event) {
        // This method should never be called
        return null;
    }
    
    protected void prepareReplyFilter (GaugeEvent event, Filter f) {
        // Prepare for FindGaugeMgr, CreateGauge, DeleteGauge, ConfigureGauge, QueryMetaInfo, QueryState, QueryValue, QueryAllValues
        if (!(event instanceof CreateGaugeEvent) &&
            !(event instanceof QueryMetaInfoEvent) &&
            !(event instanceof FindGaugeMgrEvent)) {
                addGaugeInfo (event, f);
        }
        
        if (event instanceof ConfigureGaugeEvent) {
            f.addConstraint (EVENTTYPE, CONFIGURE);
        }
        else if (event instanceof DeleteGaugeEvent) {
            f.addConstraint (EVENTTYPE, DELETE);
            f.addConstraint (GAUGEMGRID, Op.SS, ((DeleteGaugeEvent )event).gaugeMgrID);
        }
        else if (event instanceof QueryValueEvent) {
            f.addConstraint (EVENTTYPE, QUERYVALUE);
        }
        else if (event instanceof QueryAllValuesEvent) {
            f.addConstraint (EVENTTYPE, QUERYALLVALUES);
        }
        else if (event instanceof QueryGaugeStateEvent) {
            f.addConstraint (EVENTTYPE, QUERYSTATE);
        }
        else if (event instanceof CreateGaugeEvent) {
            f.addConstraint (EVENTTYPE, CREATE);
            f.addConstraint (GAUGEMGRID, Op.SS, ((CreateGaugeEvent )event).gaugeMgrID);
            f.addConstraint (EVENTID, ((CreateGaugeEvent )event).createID);
        }
        else if (event instanceof QueryMetaInfoEvent) {
            f.addConstraint (EVENTTYPE, METAINFO);
            f.addConstraint (GAUGEMGRID, Op.SS, ((QueryMetaInfoEvent )event).gaugeMgrID);
            f.addConstraint (EVENTID, ((QueryMetaInfoEvent )event).qmiID);
        }
        else if (event instanceof FindGaugeMgrEvent) {
            f.addConstraint (EVENTTYPE, FINDGMGR);
            f.addConstraint (EVENTID, ((FindGaugeMgrEvent )event).findID);
        }            
    }
    
    protected Notification prepareRequest (GaugeEvent event) {
        // Requests: FindGaugeMgr, CreateGauge, DeleteGauge, ConfigureGauge, QueryMetaInfo, QueryState,
        // QueryValue, QueryAllValues
        Notification not = null;
        
        // Determine the right event and pack it into a notification
        if (event instanceof QueryMetaInfoEvent) {
            not = ((QueryMetaInfoEvent )event).packRequest ();
        }
        else if (event instanceof ConfigureGaugeEvent) {
            not = ((ConfigureGaugeEvent )event).packRequest ();
        }
        else if (event instanceof CreateGaugeEvent) {
            // for debugging possible gauge creation race condition (zensoul-4/30/2002)
            Global.debug ("Request CreateGaugeEvent");
            Global.debug (" -> SienaEventBus current thread is " + Thread.currentThread());
            // end debugging
            not = ((CreateGaugeEvent )event).packRequest ();
        }
        else if (event instanceof DeleteGaugeEvent) {
            not = ((DeleteGaugeEvent )event).packRequest ();
        }
        else if (event instanceof QueryValueEvent) {
            not = ((QueryValueEvent )event).packRequest ();
        }
        else if (event instanceof QueryAllValuesEvent) {
            not = ((QueryAllValuesEvent )event).packRequest ();
        }
        else if (event instanceof QueryGaugeStateEvent) {
            not = ((QueryGaugeStateEvent )event).packRequest ();
        }
        else if (event instanceof FindGaugeMgrEvent) {
            not = ((FindGaugeMgrEvent )event).packRequest ();
        }        
        return not;
    }
    
    protected Notification prepareResponse (GaugeEvent event) {
        // THis method should never be called
        return null;
    }
    
    protected GaugeEvent unpackReply (Notification reply, GaugeEvent event) {
        if (event instanceof ConfigureGaugeEvent) {
            ((ConfigureGaugeEvent )event).unpackReply (reply);
        }
        else if (event instanceof DeleteGaugeEvent) {
            ((DeleteGaugeEvent )event).unpackReply (reply);
        }
        else if (event instanceof QueryValueEvent) {
            ((QueryValueEvent )event).unpackReply (reply);
        }
        else if (event instanceof QueryAllValuesEvent) {
            ((QueryAllValuesEvent )event).unpackReply (reply);
        }
        else if (event instanceof QueryGaugeStateEvent) {
            ((QueryGaugeStateEvent )event).unpackReply (reply);
        }
        else if (event instanceof CreateGaugeEvent) {
            ((CreateGaugeEvent )event).unpackReply (reply);
        }
        else if (event instanceof QueryMetaInfoEvent) {
            ((QueryMetaInfoEvent )event).unpackReply (reply);
        }
        else if (event instanceof FindGaugeMgrEvent) {
            ((FindGaugeMgrEvent )event).unpackReply (reply);
        }
        
        return event;
    }
    
    // This implements GaugeConsmumer event bus
    public boolean registerDeletedEvents (GaugeConsumer consumer, GaugeControl gauge) {
        return registerEvents (consumer, gauge, SienaEventBus.DELETED);
    }
    
    public boolean registerCreatedEvents (GaugeConsumer consumer, GaugeControl gauge) {
        return registerEvents (consumer, gauge, SienaEventBus.CREATED);
    }
    
    public boolean registerConfiguredEvents (GaugeConsumer consumer, GaugeControl gauge) {
        return registerEvents (consumer, gauge, SienaEventBus.CONFIGURED);
    }
    
    public boolean registerValueEvents (GaugeConsumer consumer, GaugeControl gauge) {
        return registerEvents (consumer, gauge, SienaEventBus.VALUE) &&
               registerEvents (consumer, gauge, SienaEventBus.MULTIPLEVALUES);
    }

    private static Notification Filter2Notification (Filter f) {
        AttributeValue av;
        Notification n = new Notification ();
        
        Iterator it = f.constraintNamesIterator ();
        while (it.hasNext ()) {
            String name = (String )it.next ();
            Iterator it2 = f.constraintsIterator (name);
            n.putAttribute (name, ((AttributeConstraint )it2.next ()).value);
        }
        
        return n;
    }
    
    private boolean registerEvents (GaugeConsumer consumer, GaugeControl gauge, String eventType) {
        Filter f = new Filter ();
        SienaEventBus.addGaugeInfo (gauge.getGaugeID (), f);
        NotificationHandlerGauge fh = new NotificationHandlerGauge ();
        f.addConstraint (EVENTTYPE, eventType);
        fh.filterAsNotification = Filter2Notification (f);
        fh.filter = f;
        fh.handler = consumer;
        fh.gauge = gauge;
        eventBindings.addElement (fh);
        try {
            siena.subscribe (f, this);
        }
        catch (SienaException ex) {
            ex.printStackTrace ();
            return false;
        }
        return true;
    }
    
    public boolean unregisterGaugeEvents (GaugeConsumer consumer, GaugeControl gauge) {
        for (int i = 0; i < eventBindings.size (); i++) {
            NotificationHandlerGauge fh = (NotificationHandlerGauge )eventBindings.elementAt (i);
            if (fh.handler == consumer && fh.gauge == gauge) {
                eventBindings.removeElementAt (i);
                i--;
                siena.unsubscribe (fh.filter, this);
            }
        }
        return true;
    }
        
}
