/*
 * CreateGaugeEvent.java
 *
 * Created on November 5, 2001, 10:20 AM
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/Siena/Events/CreateGaugeEvent.java,v 1.2 2002/01/31 16:39:07 schmerl Exp $
 * $Log: CreateGaugeEvent.java,v $
 * Revision 1.2  2002/01/31 16:39:07  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena.Events;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.SienaEventBus;
import java.util.Date;
import siena.*;
/**
 *
 * @author  schmerl
 * @version 
 */
public class CreateGaugeEvent extends GaugeEvent {

    public StringPairVector setupParams;
    
    public StringPairVector mappings;
    
    public String gaugeMgrID;
    
    public String createID;
    
    /** Creates new CreateGaugeEvent */
    public CreateGaugeEvent(GaugeID gauge) {
        xferGaugeID (gauge);
        Date d = new Date ();
        createID = d.toString ();
    }
    
    public Notification packRequest () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.CREATE);
        n.putAttribute (SienaEventBus.GAUGEMGRID, gaugeMgrID);
        n.putAttribute (SienaEventBus.EVENTID, createID);
        SienaEventBus.addGaugeInfo (this, n);
        SienaEventBus.SPV2Notification (setupParams, n, SienaEventBus.SETUP);
        SienaEventBus.SPV2Notification (mappings, n, SienaEventBus.MAPPINGS);
        return n;    
    }
    
    public static CreateGaugeEvent unpackRequest (Notification n) {
        GaugeID gaugeID = new GaugeID ();
        SienaEventBus.extractGaugeID (gaugeID, n);
        CreateGaugeEvent event = new CreateGaugeEvent (gaugeID);
        event.gaugeMgrID = n.getAttribute (SienaEventBus.GAUGEMGRID).stringValue ();
        event.createID = n.getAttribute (SienaEventBus.EVENTID).stringValue ();
        event.setupParams = new StringPairVector ();
        event.mappings = new StringPairVector ();
        SienaEventBus.Notification2SPV (n, event.setupParams, SienaEventBus.SETUP);
        SienaEventBus.Notification2SPV (n, event.mappings, SienaEventBus.MAPPINGS);
        return event;
    }
    
    public void unpackReply (Notification n) {
        status = n.getAttribute (SienaEventBus.STATUS).stringValue ().equals ("Ok");
        gaugeMgrID = n.getAttribute (SienaEventBus.GAUGEMGRID).stringValue ();
        createID = n.getAttribute (SienaEventBus.EVENTID).stringValue ();
        SienaEventBus.extractGaugeID (this, n); 
    }
    
    public Notification packReply () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.CREATE);
        n.putAttribute (SienaEventBus.GAUGEMGRID, gaugeMgrID);
        n.putAttribute (SienaEventBus.EVENTID, createID);
        SienaEventBus.addGaugeInfo (this, n);
        n.putAttribute (SienaEventBus.STATUS, status?"Ok":"Err");
        return n;
    }

}
