/*
 * DeleteGaugeEvent.java
 *
 * Created on November 5, 2001, 10:23 AM
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/Siena/Events/DeleteGaugeEvent.java,v 1.2 2002/01/31 16:39:08 schmerl Exp $
 * $Log: DeleteGaugeEvent.java,v $
 * Revision 1.2  2002/01/31 16:39:08  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena.Events;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.SienaEventBus;
import siena.*;
/**
 *
 * @author  schmerl
 * @version 
 */
public class DeleteGaugeEvent extends GaugeEvent {

    public String gaugeMgrID;
    
    /** Creates new DeleteGaugeEvent */
    public DeleteGaugeEvent(GaugeID gauge) {
        xferGaugeID (gauge);
    }

    public Notification packRequest () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.DELETE);
        n.putAttribute (SienaEventBus.GAUGEMGRID, gaugeMgrID);
        SienaEventBus.addGaugeInfo (this, n);
        return n;
    }
    
    public static DeleteGaugeEvent unpackRequest (Notification n) {
        GaugeID gaugeID = new GaugeID ();
        SienaEventBus.extractGaugeID (gaugeID, n);
        DeleteGaugeEvent event = new DeleteGaugeEvent (gaugeID);
        event.gaugeMgrID = n.getAttribute (SienaEventBus.GAUGEMGRID).stringValue ();
        return event;
    }
    
    public void unpackReply (Notification n) {
        status = n.getAttribute (SienaEventBus.STATUS).stringValue ().equals ("Ok");
        gaugeMgrID = n.getAttribute (SienaEventBus.GAUGEMGRID).stringValue ();
        SienaEventBus.extractGaugeID (this, n);
    }
    
    public Notification packReply () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.DELETE);
        n.putAttribute (SienaEventBus.GAUGEMGRID, gaugeMgrID);
        SienaEventBus.addGaugeInfo (this, n);
        n.putAttribute (SienaEventBus.STATUS, status?"Ok":"Err");
        return n; 
    }
}
