/*
 * GMgrDeleteGaugeEvent.java
 *
 * Created on November 9, 2001, 2:36 PM
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/Siena/Events/GMgrDeleteGaugeEvent.java,v 1.3 2002/02/20 20:41:28 schmerl Exp $
 * $Log: GMgrDeleteGaugeEvent.java,v $
 * Revision 1.3  2002/02/20 20:41:28  schmerl
 * 1. Fixed gauge deletion in the Siena version so that deletes don't timeout.
 * 2. Changed gauge implementation pattern so that gauge computation does not need to be included in both RMII and Siena versions.
 *
 * Revision 1.2  2002/01/31 16:39:08  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena.Events;
import edu.cmu.cs.able.gaugeInfrastructure.util.GaugeID;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.SienaEventBus;
import siena.*;
/**
 *
 * @author  schmerl
 * @version 
 */
public class GMgrDeleteGaugeEvent extends edu.cmu.cs.able.gaugeInfrastructure.Events.GaugeEvent {

    public String deleteID = null;
    public String gaugeMgrID = null;
    
    /** Creates new GMgrDeleteGaugeEvent */
    public GMgrDeleteGaugeEvent(GaugeID gauge) {
        xferGaugeID (gauge);
        deleteID = edu.cmu.cs.able.gaugeInfrastructure.Siena.Initialization.generateUniqueID ();
    }

    public GMgrDeleteGaugeEvent () {
        deleteID = edu.cmu.cs.able.gaugeInfrastructure.Siena.Initialization.generateUniqueID ();
    }
    
    public Notification packRequest () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.GMGRDELETEGAUGE);
        SienaEventBus.addGaugeInfo (this, n);
        n.putAttribute (SienaEventBus.GAUGEMGRID, this.gaugeMgrID);
        n.putAttribute (SienaEventBus.EVENTID, this.deleteID);
        return n;
    }
    
    public static GMgrDeleteGaugeEvent unpackRequest (Notification n) {
        GaugeID gaugeID = new GaugeID ();
        SienaEventBus.extractGaugeID (gaugeID, n);
        GMgrDeleteGaugeEvent event = new GMgrDeleteGaugeEvent (gaugeID);
        event.gaugeMgrID = n.getAttribute(SienaEventBus.GAUGEMGRID).stringValue();
        event.deleteID = n.getAttribute(SienaEventBus.EVENTID).stringValue ();
        return event;
        
    }
    
    public void unpackReply (Notification n) {
        status = n.getAttribute (SienaEventBus.STATUS).stringValue ().equals ("Ok");
        if (status) {
            SienaEventBus.extractGaugeID (this, n);
            gaugeMgrID = n.getAttribute (SienaEventBus.GAUGEMGRID).stringValue ();
            deleteID = n.getAttribute (SienaEventBus.EVENTID).stringValue ();
        } 
    }
    
    public Notification packReply () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.GMGRDELETEGAUGE);
        SienaEventBus.addGaugeInfo (this, n);
        n.putAttribute (SienaEventBus.GAUGEMGRID, gaugeMgrID);
        n.putAttribute (SienaEventBus.EVENTID, deleteID);
        n.putAttribute (SienaEventBus.STATUS, status?"Ok":"Err");
        return n;
    }
}
