/*
 * GaugeInitEvent.java
 *
 * Created on November 6, 2001, 1:21 PM
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/Siena/Events/GaugeInitEvent.java,v 1.2 2002/01/31 16:39:08 schmerl Exp $
 * $Log: GaugeInitEvent.java,v $
 * Revision 1.2  2002/01/31 16:39:08  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena.Events;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.SienaEventBus;
import siena.*;
/**
 *
 * @author  schmerl
 * @version 
 */
public class GaugeInitEvent extends edu.cmu.cs.able.gaugeInfrastructure.Events.GaugeEvent {

    public StringPairVector setup = new StringPairVector();
    
    public StringPairVector mappings = new StringPairVector();
    
    public String gaugeMgrID = "";
    
    /** Creates new GaugeInitEvent */
    public GaugeInitEvent(GaugeID gauge) {
        xferGaugeID (gauge);
    }

    public Notification packRequest () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.GAUGEINIT);
        SienaEventBus.addGaugeInfo (this, n);
        n.putAttribute (SienaEventBus.GAUGEMGRID, gaugeMgrID);
        return n;
    }
    
    public static GaugeInitEvent unpackRequest (Notification n) {
        GaugeID gaugeID = new GaugeID ();
        SienaEventBus.extractGaugeID (gaugeID, n);
        GaugeInitEvent event = new GaugeInitEvent (gaugeID);
        event.gaugeMgrID = n.getAttribute (SienaEventBus.GAUGEMGRID).stringValue ();
        return event; 
        
    }
    
    public void unpackReply (Notification n) {
        gaugeMgrID = n.getAttribute (SienaEventBus.GAUGEMGRID).stringValue ();
        status = n.getAttribute (SienaEventBus.STATUS).stringValue ().equals ("Ok");
        if (status) {
            SienaEventBus.Notification2SPV (n, setup, SienaEventBus.SETUP);
            SienaEventBus.Notification2SPV (n, mappings, SienaEventBus.MAPPINGS);
        }
    }
    
    public Notification packReply () {
       Notification n = new Notification ();
        SienaEventBus.addGaugeInfo (this, n);
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.GAUGEINIT);
        n.putAttribute (SienaEventBus.GAUGEMGRID, gaugeMgrID);
        SienaEventBus.SPV2Notification (setup, n, SienaEventBus.SETUP);
        SienaEventBus.SPV2Notification (mappings, n, SienaEventBus.MAPPINGS);
        n.putAttribute (SienaEventBus.STATUS, status?"Ok":"Err");
        return n;
    }
}
