/*
 * QueryAllValuesEvent.java
 *
 * Created on November 5, 2001, 10:26 AM
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/Siena/Events/QueryAllValuesEvent.java,v 1.2 2002/01/31 16:39:08 schmerl Exp $
 * $Log: QueryAllValuesEvent.java,v $
 * Revision 1.2  2002/01/31 16:39:08  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena.Events;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.SienaEventBus;
import siena.*;
/**
 *
 * @author  schmerl
 * @version 
 */
public class QueryAllValuesEvent extends GaugeEvent {

    public GaugeValueVector values;
    public String consumerID;
    
    /** Creates new QueryAllValuesEvent */
    public QueryAllValuesEvent(GaugeID gauge) {
        xferGaugeID (gauge);
    }

    public Notification packRequest () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.QUERYALLVALUES);
        SienaEventBus.addGaugeInfo (this, n);
        return n;
    }
    
    public static QueryAllValuesEvent unpackRequest (Notification n) {
        GaugeID gaugeID = new GaugeID ();
        SienaEventBus.extractGaugeID (gaugeID, n);
        QueryAllValuesEvent event = new QueryAllValuesEvent (gaugeID);
        return event;
    }
    
    public void unpackReply (Notification n) {
        status = n.getAttribute (SienaEventBus.STATUS).stringValue ().equals ("Ok");
        if (status) {
            values = new GaugeValueVector ();
            SienaEventBus.Notification2GVV (n, values, SienaEventBus.VALUE);
        }
    }
    
    public Notification packReply () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.QUERYALLVALUES);
        SienaEventBus.addGaugeInfo (this, n);
        SienaEventBus.GVV2Notification (this.values, n, SienaEventBus.VALUE);
        n.putAttribute ("status", status?"Ok":"Err");
        return n;
    }
}
