/*
 * QueryGaugeStateEvent.java
 *
 * Created on November 5, 2001, 10:10 AM
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/Siena/Events/QueryGaugeStateEvent.java,v 1.2 2002/01/31 16:39:08 schmerl Exp $
 * $Log: QueryGaugeStateEvent.java,v $
 * Revision 1.2  2002/01/31 16:39:08  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena.Events;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.SienaEventBus;
import siena.*;
/**
 *
 * @author  schmerl
 * @version 
 */
public class QueryGaugeStateEvent extends edu.cmu.cs.able.gaugeInfrastructure.Events.GaugeEvent {

    public StringPairVector setupParams;
    
    public StringPairVector configParams;
    
    public StringPairVector mappings;
        public String consumerID;
    /** Creates new QueryGaugeStateEvent */
    public QueryGaugeStateEvent(GaugeID gauge) {
        xferGaugeID (gauge);
    }

    public java.lang.String toString() {
        return "QUERYSTATE";
    }

    public Notification packRequest () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.QUERYSTATE);
        SienaEventBus.addGaugeInfo (this, n);
        return n;
    }
    
    public static QueryGaugeStateEvent unpackRequest (Notification n) {
        GaugeID gaugeID = new GaugeID ();
        SienaEventBus.extractGaugeID (gaugeID, n);
        return new QueryGaugeStateEvent (gaugeID);
    }
    
    public void unpackReply (Notification n) {
        status = n.getAttribute (SienaEventBus.STATUS).stringValue ().equals ("Ok");
        if (this.status) {
            this.setupParams = new StringPairVector ();
            this.configParams = new StringPairVector ();
            this.mappings = new StringPairVector ();
            SienaEventBus.Notification2SPV (n, this.setupParams, SienaEventBus.SETUP);
            SienaEventBus.Notification2SPV (n, this.configParams, SienaEventBus.CONFIG);
            SienaEventBus.Notification2SPV (n, this.mappings, SienaEventBus.MAPPINGS);
        }
    }
    
    public Notification packReply () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.QUERYSTATE);
        n.putAttribute (SienaEventBus.STATUS, status?"Ok":"Err");
        SienaEventBus.addGaugeInfo (this, n);
        SienaEventBus.SPV2Notification (this.setupParams, n, SienaEventBus.SETUP);
        SienaEventBus.SPV2Notification (this.configParams, n, SienaEventBus.CONFIG);
        SienaEventBus.SPV2Notification (this.mappings, n, SienaEventBus.MAPPINGS);
        return n;
    }    
}
