/*
 * QueryMetaInfoEvent.java
 *
 * Created on November 5, 2001, 10:17 AM
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/Siena/Events/QueryMetaInfoEvent.java,v 1.2 2002/01/31 16:39:08 schmerl Exp $
 * $Log: QueryMetaInfoEvent.java,v $
 * Revision 1.2  2002/01/31 16:39:08  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena.Events;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.SienaEventBus;
import siena.*;
import java.util.Date;
/**
 *
 * @author  schmerl
 * @version 
 */
public class QueryMetaInfoEvent extends GaugeEvent {

    /** Creates new QueryMetaInfoEvent */
    public QueryMetaInfoEvent(String gaugeType) {
        this.gaugeType = gaugeType;
        Date d = new Date ();
        qmiID = d.toString ();
    }
    
    public String gaugeMgrID;
    public StringPairVector configParams = new StringPairVector ();
    public StringPairVector values = new StringPairVector ();
    public String qmiID;

    public Notification packRequest () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.METAINFO); 
        n.putAttribute (SienaEventBus.GAUGEMGRID, this.gaugeMgrID);
        n.putAttribute (SienaEventBus.EVENTID, this.qmiID);
        n.putAttribute (SienaEventBus.GAUGETYPE, this.gaugeType);
        return n;
    }
    
    public static QueryMetaInfoEvent unpackRequest (Notification n) {
        String gaugeType = n.getAttribute (SienaEventBus.GAUGETYPE).stringValue ();
        QueryMetaInfoEvent event = new QueryMetaInfoEvent (gaugeType);
        event.qmiID = n.getAttribute (SienaEventBus.EVENTID).stringValue ();
        return event;
    }
    
    public void unpackReply (Notification n) {
        this.status = n.getAttribute (SienaEventBus.STATUS).stringValue ().equals ("Ok");
        if (this.status) {
            this.gaugeType = n.getAttribute (SienaEventBus.GAUGETYPE).stringValue ();
            this.gaugeMgrID = n.getAttribute (SienaEventBus.GAUGEMGRID).stringValue ();
            this.qmiID = n.getAttribute (SienaEventBus.EVENTID).stringValue ();
            SienaEventBus.Notification2SPV (n, this.configParams, SienaEventBus.CONFIG);
            SienaEventBus.Notification2SPV (n, this.values, SienaEventBus.VALUE);
        }
    }
    
    public Notification packReply () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.METAINFO);
        n.putAttribute (SienaEventBus.GAUGEMGRID, this.gaugeMgrID);
        n.putAttribute (SienaEventBus.GAUGETYPE, this.gaugeType);
        n.putAttribute (SienaEventBus.EVENTID, this.qmiID);
        SienaEventBus.SPV2Notification (this.configParams, n, SienaEventBus.CONFIG);
        SienaEventBus.SPV2Notification (this.values, n, SienaEventBus.VALUE);
        n.putAttribute (SienaEventBus.STATUS, this.status?"Ok":"Err");
        return n;
    } 
}
