/*
 * QueryValueEvent.java
 *
 * Created on November 5, 2001, 10:25 AM
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/Siena/Events/QueryValueEvent.java,v 1.2 2002/01/31 16:39:09 schmerl Exp $
 * $Log: QueryValueEvent.java,v $
 * Revision 1.2  2002/01/31 16:39:09  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena.Events;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.SienaEventBus;
import siena.*;
/**
 *
 * @author  schmerl
 * @version 
 */
public class QueryValueEvent extends GaugeEvent {

    public String valueName;
    
    public String value;
    public String consumerID;
    /** Creates new QueryValueEvent */
    public QueryValueEvent(GaugeID gauge) {
        xferGaugeID (gauge);
    }

    public Notification packRequest () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.QUERYVALUE);
        n.putAttribute (SienaEventBus.VALUENAME, this.valueName);
        SienaEventBus.addGaugeInfo (this, n);
        return n;
    }
    
    public static QueryValueEvent unpackRequest (Notification n) {
        GaugeID gaugeID = new GaugeID ();
        SienaEventBus.extractGaugeID (gaugeID, n);
        QueryValueEvent event = new QueryValueEvent (gaugeID);
        event.valueName = n.getAttribute (SienaEventBus.VALUENAME).stringValue ();
        return event;
    }
    
    public void unpackReply (Notification n) {
        this.status = n.getAttribute (SienaEventBus.STATUS).stringValue ().equals ("Ok");
        if (this.status) {
            this.valueName = n.getAttribute (SienaEventBus.VALUENAME).stringValue ();
            this.value = n.getAttribute (SienaEventBus.VALUE).stringValue ();
        }
    }
    
    public Notification packReply () {
        Notification n = new Notification ();
        n.putAttribute (SienaEventBus.EVENTTYPE, SienaEventBus.QUERYVALUE);
        SienaEventBus.addGaugeInfo (this, n);
        n.putAttribute (SienaEventBus.VALUENAME, this.valueName);
        n.putAttribute (SienaEventBus.VALUE, this.value);
        n.putAttribute (SienaEventBus.STATUS, this.status?"Ok":"Err");
        return n;
    } 
}
