/*
 * Initialization.java
 *
 * Created on November 6, 2001, 3:17 PM
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/Siena/Initialization.java,v 1.2 2002/01/31 16:39:06 schmerl Exp $
 * $Log: Initialization.java,v $
 * Revision 1.2  2002/01/31 16:39:06  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.*;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Date;
/**
 *
 * @author  schmerl
 * @version 
 */
public class Initialization {

    public static final int GAUGEMGR = 1;
    public static final int GAUGECONS = 2;
    public static final int GAUGE = 4;
  
    public static GMgrSideEventBus gaugeMgrBus = null;
    public static GaugeSideEventBus gaugeBus = null;
    public static ConsumerSideEventBus gaugeConsBus = null;
    
    /** Creates new Initialization */
    public Initialization() {
    }

    public static void initSiena(String senp, int busFlags) {
        if ((busFlags & GAUGEMGR) == GAUGEMGR) {
            gaugeMgrBus = new GMgrSideEventBus (senp);
        }
        if ((busFlags & GAUGECONS) == GAUGECONS) {
            gaugeConsBus = new ConsumerSideEventBus (senp);
        }
        if ((busFlags & GAUGE) == GAUGE) {
            gaugeBus = new GaugeSideEventBus (senp);
        }
    }
    
    public static String generateUniqueID () {
        Date d = new Date ();
        InetAddress addr;
        try {
            addr = InetAddress.getLocalHost ();
        }
        catch (UnknownHostException ex) {
            return "unknown@" + d.toString ();
        }
        return addr.getHostAddress () + "@" + d.toString ();
    }
    

    
}
