 /*
 * SienaGaugeConsumer.java
 *
 * Created on November 6, 2001, 5:35 PM
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/Siena/SienaGaugeConsumer.java,v 1.2 2002/01/31 16:39:06 schmerl Exp $
 * $Log: SienaGaugeConsumer.java,v $
 * Revision 1.2  2002/01/31 16:39:06  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.*;
import java.util.*;
/** A stub implementation of the a gauge consumer that listens to
 * siena gauges.
 *
 * @author Bradley Schmerl
 * @version 1.1
 */
public class SienaGaugeConsumer implements edu.cmu.cs.able.gaugeInfrastructure.GaugeConsumer{

    /** The gauges that this consumer is listening to.
     */    
    public Vector gauges;
    
    /** The gauge managers that this consumer can use to create gauges.
     */    
    public Vector gaugeMgrs;
    
    /** The reporting bus that gauges report through.
     */    
    public GaugeReportingBus reportingBus = new SienaGaugeReportingBus ();
    
    Thread interactionThread = null;
    
    /** Creates new SienaGaugeConsumer */
    public SienaGaugeConsumer() {
    }

    /**
     * @param gauge
     * @param configParams  */    
    public void onReportConfigured(GaugeControl gauge, StringPairVector configParams) {
        System.out.println ("Gauge: " + gauge.getGaugeID ().toString () + " was reconfigured. New configuration is:");
        for (int i = 0; i < configParams.size (); i++) {
            System.out.println ("  " + configParams.nameAt (i) + " : " + configParams.valueAt (i));
        }
    }
   
    /**
     * @param gauge  */    
    public void onReportCreated(GaugeControl gauge) {
        System.out.println ("Gauge: " + gauge.getGaugeID().toString () + " was created.");
    }
    
    /**
     * @param gauge  */    
    public void onReportDeleted(GaugeControl gauge) {
        System.out.println ("Gauge: " + gauge.getGaugeID ().toString () + " was deleted.");
    }
    
    /**
     * @param gauge
     * @param values  */    
    public void onReportMultipleValues(GaugeControl gauge, GaugeValueVector values) {
        System.out.println ("Guage: " + gauge.getGaugeID ().toString () + " reported the values:");
        for (int i = 0; i < values.size (); i++) {
            System.out.println ("  " + values.nameAt (i) + " : " + values.propertyAt (i) + " = " + values.valueAt (i));
        }
    }
    
    /**
     * @param gauge
     * @param valueName
     * @param propertyName
     * @param value  */    
    public void onReportValue(GaugeControl gauge, String valueName, String propertyName, String value) {
        System.out.println ("Gauge: " + gauge.getGaugeID ().toString () + " reported the value:");
        System.out.println ("  " + valueName + " : " + propertyName + " = " + value);
    }
}
