/*
 * SienaGaugeMgrHandle.java
 *
 * Created on November 5, 2001, 11:36 AM
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/Siena/SienaGaugeMgrHandle.java,v 1.3 2002/05/13 14:36:30 zensoul Exp $
 * $Log: SienaGaugeMgrHandle.java,v $
 * Revision 1.3  2002/05/13 14:36:30  zensoul
 * Diagnostic output for deleteGauge(), changed to use Global.debug().
 *
 * Revision 1.2  2002/01/31 16:39:07  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.Events.*;
/**
 *
 * @author  schmerl
 * @version 
 */
public class SienaGaugeMgrHandle implements edu.cmu.cs.able.gaugeInfrastructure.GaugeMgr {

    static ConsumerSideEventBus eventBus = null;; 
    public String gaugeMgrID = null;
    
    /** Creates new SienaGaugeMgrHandle */
    public SienaGaugeMgrHandle(String gaugeType) {
        eventBus = Initialization.gaugeConsBus;
        // Find a gauge manager that manages gauge type
        FindGaugeMgrEvent request = new FindGaugeMgrEvent (gaugeType);
        FindGaugeMgrEvent reply = new FindGaugeMgrEvent (gaugeType);
        reply = (FindGaugeMgrEvent )eventBus.publishRequest (request);
        //eventBus.waitForReply (reply); 
        
        if (reply.status) {
            gaugeMgrID = reply.gaugeMgrID;
        }
    }
    
    public String getGaugeMgrID () {
        return gaugeMgrID;
    }

    // number of retries is passsed to the Gauges to help determine how long to timelong
    public GaugeControl createGauge(GaugeID gauge, StringPairVector setupParams, StringPairVector mappings) {
        CreateGaugeEvent request = new CreateGaugeEvent (gauge);
        CreateGaugeEvent reply = new CreateGaugeEvent (gauge);
        request.gaugeMgrID = gaugeMgrID;
        reply.gaugeMgrID = gaugeMgrID;
        request.setupParams = setupParams;
        request.mappings = mappings;
        reply = (CreateGaugeEvent )eventBus.publishRequest (request);
        //eventBus.waitForReply (reply);
        
        if (reply.status) {
            SienaGaugeHandle handle = new SienaGaugeHandle (reply);
            return handle;
        }
        else {
            return null;
        }
    }
    
    public boolean deleteGauge(GaugeControl gauge) {
        DeleteGaugeEvent request = new DeleteGaugeEvent (gauge.getGaugeID ());
        DeleteGaugeEvent reply = new DeleteGaugeEvent (gauge.getGaugeID ());
        request.gaugeMgrID = gaugeMgrID;
        edu.cmu.cs.able.gaugeInfrastructure.util.Global.debug ("SienaGaugeMgrHandle: publishing DeleteGaugeEvent request...");
        reply = (DeleteGaugeEvent )eventBus.publishRequest (request);
        edu.cmu.cs.able.gaugeInfrastructure.util.Global.debug ("SienaGaugeMgrHandle: published DeleteGaugeEvent...");
        //eventBus.waitForReply (reply);
        
        return reply.status;
    }
    
    public boolean managesType(String gaugeType) {
        return true;
    }
     
    public boolean queryMetaInfo(String gaugeType, StringPairVector configParamsMeta, StringPairVector valuesMeta) {
        QueryMetaInfoEvent request = new QueryMetaInfoEvent (gaugeType);
        QueryMetaInfoEvent reply = new QueryMetaInfoEvent (gaugeType);
        request.gaugeMgrID = gaugeMgrID;
        reply = (QueryMetaInfoEvent )eventBus.publishRequest (request);
        //eventBus.waitForReply (reply);
        if (reply.status) {
            reply.configParams.copyInto (configParamsMeta);
            reply.values.copyInto (valuesMeta);
        }
        return reply.status;
        
    }
}
